package DiversityPackage;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.Set;
import org.apache.jena.ext.com.google.common.collect.LinkedListMultimap;
import org.apache.jena.ext.com.google.common.collect.Multimap;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DataFormatter;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class AcrossDisparity {
	static XSSFRow row;

	public static Hashtable<String, Double> AcrossDisparity = new Hashtable();
	public static Hashtable<Integer, LinkedList<Double>> CosineSimilarityPerVidoe = new Hashtable();
	public static LinkedHashMap<String, LinkedHashMap<String, Double>> CategoriesCosdineSimilarityPerVideo = new <Integer, LinkedHashMap<String, Double>>LinkedHashMap();

	public static void main(String[] args) throws IOException {

		InputStream inp = new FileInputStream("StudyA-FrequencyVector-IndividualLevel-OnlineCopy.xlsx");

		XSSFWorkbook workbook = new XSSFWorkbook(inp);
		XSSFSheet spreadsheet = workbook.getSheetAt(0);
		DataFormatter fmt = new DataFormatter();

		// Get data from EXCEL
		Multimap<XSSFCell, LinkedList> CategoryFreq = LinkedListMultimap.create();
		Iterator<Row> rowIterator = spreadsheet.iterator();
		while (rowIterator.hasNext()) {
			LinkedList<Integer> freq = new LinkedList<Integer>();
			row = (XSSFRow) rowIterator.next();
			if (row.getRowNum() > 0) // To filter column headings
			{
				Iterator<Cell> cellIterator = row.cellIterator();
				while (cellIterator.hasNext()) {
					Cell cell = cellIterator.next();
					if (cell.getColumnIndex() > 0)// get the required columns
					{
						freq.add((int) cell.getNumericCellValue());
					}

				}
				// adds every cell associated with a v ID e.g. <1,4>, then <1,9>. The other
				// multimap collects them as a row e.g. <1,{4,9}>
				CategoryFreq.put(row.getCell(0), freq);

			}
		}

		// Save the data in another multimap (collects records): e.g. <1,{4,9}>
		Multimap<XSSFCell, LinkedList> CategoryFreqPerVideo = LinkedListMultimap.create();
		Set<XSSFCell> keys = CategoryFreq.keySet();
		for (XSSFCell VID : keys) {
			Collection<LinkedList> EList = CategoryFreq.get(VID);
			LinkedList<?> E = new LinkedList<Object>();
			EList.forEach(E::addAll);
			CategoryFreqPerVideo.put(VID, E);
		}
		// Now as we have duplicates for the key, we need to get data per key (video ID)
		// to create the vectors
		// Hashtable <Double,LinkedList> CosineSimPerVID=new Hashtable();
		Set<XSSFCell> key = CategoryFreqPerVideo.keySet();

		// Depends on video Id data type Integer (e.g. 1) or String (e.g. T1)
		// for (Integer VID : getDigitalObjectIdSet(key))
		for (String VID : getDigitalObjectIdSet(key)) {
			// LinkedList<XSSFCell> cells =
			// filterKeySet(CategoryFreqPerVideo.keySet(),VID.intValue());
			LinkedList<XSSFCell> cells = filterKeySet(CategoryFreqPerVideo.keySet(), VID);
			// Collection<LinkedList> collection=new Collection<LinkedList>();
			LinkedList<Integer> Firsts = new LinkedList<Integer>();
			LinkedList<Integer> Seconds = new LinkedList<Integer>();
			LinkedList<Integer> Thirds = new LinkedList<Integer>();
			LinkedList<Integer> Forths = new LinkedList<Integer>();
			// LinkedList<Integer> Fifths=new LinkedList<Integer>();// depends on number of
			// ontology categories
			// LinkedList<Integer> sixths=new LinkedList<Integer>();
			// get data per video ID
			for (XSSFCell cell : cells) {
				Collection<LinkedList> collection = CategoryFreqPerVideo.get(cell);

				// flatten the collection to a linked list
				LinkedList<Integer> E = new LinkedList<Integer>();
				collection.forEach(E::addAll);
				// copy the linked list to remove elements from copy to create the vectors: DOES
				// it make change if we use E directly??
				LinkedList<Integer> Ecopy = new LinkedList<Integer>(E);
				// create the vectors over iterations
				Firsts.add(Ecopy.getFirst());
				Ecopy.removeFirst();
				Seconds.add(Ecopy.getFirst());
				Ecopy.removeFirst();
				Thirds.add(Ecopy.getFirst());
				Ecopy.removeFirst();
				Forths.add(Ecopy.getFirst());
				// Ecopy.removeFirst();
				/*
				 * Fifths.add(Ecopy.getFirst()); Ecopy.removeFirst();
				 * sixths.add(Ecopy.getFirst());
				 */
				// there must be at least one element in every list as frequency =0 is added
				// when there is no frequency for a category
				// e.g. a video has the following frequencies per category:
				// c1=2,c2=3,c3=0,c4=0,c5=0,c6=1 so vector three, four, and five has size value
				// one and one elements zeros
			}
			// find variety
			int v = 0;
			// v=FindVariety(Firsts,Seconds,Thirds,Forths,Fifths,sixths); // body language
			// ontology
			v = FindVariety(Firsts, Seconds, Thirds, Forths);// PreSOn
			// CalculateCosineSimilarity(VID,Firsts,Seconds,Thirds,Forths,Fifths,sixths,v);
			CalculateCosineSimilarity(VID, Firsts, Seconds, Thirds, Forths, v);
		}

		Iterator<String> e3 = CategoriesCosdineSimilarityPerVideo.keySet().iterator();
		while (e3.hasNext()) {
			// Integer Vid=e3.next();
			String Vid = e3.next();
			LinkedHashMap<String, Double> CosineSim = CategoriesCosdineSimilarityPerVideo.get(Vid);
			System.out.print(Vid + "\t");
			Iterator<String> e4 = CosineSim.keySet().iterator();
			;
			while (e4.hasNext()) {
				String category = e4.next();
				Double cosine = CosineSim.get(category);
				// System.out.print(category+"\t"+cosine+"\t");
				System.out.print(cosine + "\t");
			}
			System.out.println();
		}
		System.out.println();
		System.out.println("********************************************************************************");
		System.out.println();
		// Enumeration <Integer> e2=AcrossDisparity.keys();
		Enumeration<String> e2 = AcrossDisparity.keys();
		while (e2.hasMoreElements()) {
			// Integer vid=e2.nextElement();
			String vid = e2.nextElement();
			Double AcrossDiss = AcrossDisparity.get(vid);
			System.out.print(vid + "\t" + AcrossDiss);
			System.out.println();
		}
		inp.close();
	}

	/**
	 * 
	 * @param firsts
	 * @param seconds
	 * @param thirds
	 * @param forths
	 * @param fifths
	 * @param sixths
	 * @return
	 */
	// private static int FindVariety(LinkedList<Integer> firsts,
	// LinkedList<Integer> seconds, LinkedList<Integer> thirds,
	// LinkedList<Integer> forths, LinkedList<Integer> fifths, LinkedList<Integer>
	// sixths) {
	private static int FindVariety(LinkedList<Integer> firsts, LinkedList<Integer> seconds, LinkedList<Integer> thirds,
			LinkedList<Integer> forths) {
		int v = 0;
		int fsize = 0;
		for (int i = 0; i < firsts.size(); i++) {
			if (firsts.get(i) == 0) {

				fsize++;
			}
		}
		if (!(fsize == firsts.size())) {
			v++;
		}
		int sesize = 0;
		for (int j = 0; j < seconds.size(); j++) {
			if (seconds.get(j) == 0) {

				sesize++;
			}
		}
		if (!(sesize == seconds.size()))
			v++;
		int tsize = 0;
		for (int k = 0; k < thirds.size(); k++) {
			if (thirds.get(k) == 0) {

				tsize++;
			}
		}
		if (!(tsize == thirds.size()))
			v++;
		int fosize = 0;
		for (int n = 0; n < forths.size(); n++) {
			if (forths.get(n) == 0) {

				fosize++;
			}
		}
		if (!(fosize == forths.size()))
			v++;

		/*
		 * int fifsize=0;
		 * 
		 * for (int m=0;m<fifths.size();m++) { if(fifths.get(m)==0) {
		 * 
		 * fifsize++; } } if (!(fifsize==fifths.size())) v++; int ssize=0;
		 * 
		 * for (int o=0;o<sixths.size();o++) { if(sixths.get(o)==0) {
		 * 
		 * ssize++; } }
		 * 
		 * if (!(ssize==sixths.size())) v++;
		 */
		return v;
	}

	// private static Hashtable CalculateCosineSimilarity(Integer vID,
	// LinkedList<Integer> firsts, LinkedList<Integer> seconds, LinkedList<Integer>
	// thirds,
	// LinkedList<Integer> forths, LinkedList<Integer> fifths, LinkedList<Integer>
	// sixths, int v)
	private static Hashtable CalculateCosineSimilarity(String vID, LinkedList<Integer> firsts,
			LinkedList<Integer> seconds, LinkedList<Integer> thirds, LinkedList<Integer> forths, int v) {
		LinkedList<Double> CosineSimilarities = new LinkedList();
		LinkedHashMap<String, Double> CategoriesSimilarityPerVideo = new <String, Double>LinkedHashMap();
		// vectors with only zeros will not be passed to cosine calculations
		if (!(firsts.stream().allMatch(e -> e == 0) || seconds.stream().allMatch(e -> e == 0))) {

			CategoriesSimilarityPerVideo.put("BL&BLSM", CalculateCosine(firsts, seconds));// to get the category name
																							// and value for Stirling/
																							// remove when across
																							// disparity is needed or
																							// adjust
		}

		else {
			CategoriesSimilarityPerVideo.put("BL&BLSM", 0.0);
		}

		if (!(firsts.stream().allMatch(e -> e == 0) || thirds.stream().allMatch(e -> e == 0))) {

			CategoriesSimilarityPerVideo.put("BL&BM", CalculateCosine(firsts, thirds));
		}

		else {
			CategoriesSimilarityPerVideo.put("BL&BM", 0.0);
		}

		if (!(firsts.stream().allMatch(e -> e == 0) || forths.stream().allMatch(e -> e == 0))) {

			CategoriesSimilarityPerVideo.put("BL&BSF", CalculateCosine(firsts, forths));
		}

		else {
			CategoriesSimilarityPerVideo.put("BL&BSF", 0.0);
		}

		/*
		 * if(!(firsts.stream().allMatch(e -> e==0) || fifths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BL&O",CalculateCosine(firsts,fifths)); }
		 * 
		 * else { CategoriesSimilarityPerVideo.put("BL&O",0.0); }
		 * 
		 * if(!(firsts.stream().allMatch(e -> e==0) || sixths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BL&BP",CalculateCosine(firsts,sixths)); }
		 * else { CategoriesSimilarityPerVideo.put("BL&BP",0.0); }
		 */

		if (!(seconds.stream().allMatch(e -> e == 0) || thirds.stream().allMatch(e -> e == 0))) {

			CategoriesSimilarityPerVideo.put("BLSM&BM", CalculateCosine(seconds, thirds));
		}

		else {
			CategoriesSimilarityPerVideo.put("BLSM&BM", 0.0);
		}

		if (!(seconds.stream().allMatch(e -> e == 0) || forths.stream().allMatch(e -> e == 0))) {

			CategoriesSimilarityPerVideo.put("BLSM&BSF", CalculateCosine(seconds, forths));
		}

		else {
			CategoriesSimilarityPerVideo.put("BLSM&BSF", 0.0);
		}

		/*
		 * if(!(seconds.stream().allMatch(e -> e==0) || fifths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BLSM&O",CalculateCosine(seconds,fifths)); }
		 * 
		 * else { CategoriesSimilarityPerVideo.put("BLSM&O",0.0); }
		 * 
		 * if(!(seconds.stream().allMatch(e -> e==0) || sixths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BLSM&BP",CalculateCosine(seconds,sixths));
		 * }
		 * 
		 * else { CategoriesSimilarityPerVideo.put("BLSM&BP",0.0); }
		 */

		if (!(thirds.stream().allMatch(e -> e == 0) || forths.stream().allMatch(e -> e == 0))) {

			CategoriesSimilarityPerVideo.put("BM&BSF", CalculateCosine(thirds, forths));
		}

		else {
			CategoriesSimilarityPerVideo.put("BM&BSF", 0.0);
		}

		/*
		 * if(!(thirds.stream().allMatch(e -> e==0) || fifths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BM&O",CalculateCosine(thirds,fifths)); }
		 * 
		 * else { CategoriesSimilarityPerVideo.put("BM&O",0.0); }
		 * 
		 * if(!(thirds.stream().allMatch(e -> e==0) || sixths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BM&BP",CalculateCosine(thirds,sixths)); }
		 * else { CategoriesSimilarityPerVideo.put("BM&BP",0.0); }
		 * 
		 * if(!(forths.stream().allMatch(e -> e==0) || fifths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BSF&O",CalculateCosine(forths,fifths)); }
		 * 
		 * else { CategoriesSimilarityPerVideo.put("BSF&O",0.0); }
		 * 
		 * if(!(forths.stream().allMatch(e -> e==0) || sixths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("BSF&BP",CalculateCosine(forths,sixths)); }
		 * 
		 * else { CategoriesSimilarityPerVideo.put("BSF&BP",0.0); }
		 * 
		 * if(!(fifths.stream().allMatch(e -> e==0) || sixths.stream().allMatch(e ->
		 * e==0))) {
		 * 
		 * CategoriesSimilarityPerVideo.put("O&BP",CalculateCosine(fifths,sixths)); }
		 * else { CategoriesSimilarityPerVideo.put("O&BP",0.0); }
		 */

		CategoriesCosdineSimilarityPerVideo.put(vID, CategoriesSimilarityPerVideo);

		// calculate across disparity/average
		LinkedList<Double> CosineSim = new LinkedList();
		Iterator<String> e4 = CategoriesSimilarityPerVideo.keySet().iterator();
		while (e4.hasNext()) {
			String category = e4.next();
			Double cosine = CategoriesSimilarityPerVideo.get(category);
			CosineSim.add(cosine);
		}
		if (!(CosineSim.size() == 0)) {
			Double aveDis = CalculateAverageDissimilarity(vID, CosineSim, v); // variety (v)

		}

		return CosineSimilarityPerVidoe;
	}

	/**
	 * 
	 * @param firsts
	 * @param seconds
	 * @return
	 */
	private static double CalculateCosine(LinkedList<Integer> firsts, LinkedList<Integer> seconds) {
		Integer dotProduct = 0;
		Integer v1 = 0;
		Integer v2 = 0;
		double squares = 0;
		double cosine = 0.0;
		for (int i = 0; i < firsts.size(); i++) {
			dotProduct += firsts.get(i) * seconds.get(i);
			v1 += firsts.get(i) * firsts.get(i);
			v2 += seconds.get(i) * seconds.get(i);
		}
		squares = (Math.sqrt(v1) * Math.sqrt(v2));
		if (!(squares == 0)) {
			cosine = dotProduct / squares;
		}

		return cosine;
	}

	/**
	 * 
	 * @param vID
	 * @param cosineSimilarities
	 * @param j
	 * @return
	 */
	// private static Double CalculateAverageDissimilarity(Integer vID,
	// LinkedList<Double> cosineSimilarities, int j) {
	private static Double CalculateAverageDissimilarity(String vID, LinkedList<Double> cosineSimilarities, int j) {
		// Hashtable <Integer,Double> AcrossDisparity =new Hashtable();
		double AvergaeDiss = 0.0;// average dissimilarity=1/n(n-1)*Sum(dij) dij is cosine similarity is it
									// 1-cosine similarity?
		double distanceSum = 0.0;
		double n = 0.0;
		for (int i = 0; i < cosineSimilarities.size(); i++) {
			if (!(cosineSimilarities.get(i) == 0)) {
				distanceSum += (1 - cosineSimilarities.get(i));
			}
		}

		if (!(j == 1)) // variety is not 1- cannot perform pair-wise comparison with variety 1 based on
						// cosine similarity index
		{
			n = 1 / (double) j * ((double) j - 1);// 1/n*(n-1)
			// System.out.println(n);
			AvergaeDiss = n * distanceSum;
		}
		AcrossDisparity.put(vID, AvergaeDiss);

		return AvergaeDiss;
	}

	/**
	 * 
	 * @param list
	 */
	private static void PrintLinkedList(LinkedList<?> list) {
		System.out.println(
				"The list has" + "\t" + list.size() + "\t" + "elements" + "\t" + "and it looks like the following:");
		Iterator<?> i = list.iterator();
		while (i.hasNext()) {
			System.out.print(i.next() + "\t");

		}
		System.out.println();
	}

	/**
	 * 
	 * @param keys
	 * @param vID
	 * @return
	 */
	// based on video ID type- can be a number (e.g. 100) or String (e.g. E3)
	// public static LinkedList<XSSFCell> filterKeySet(Set<XSSFCell> keys, int vID)
	// {
	public static LinkedList<XSSFCell> filterKeySet(Set<XSSFCell> keys, String vID) {
		LinkedList<XSSFCell> answer = new LinkedList<XSSFCell>();
		for (XSSFCell xssfCell : keys) {
			// if (xssfCell.equals(vID)) // use for each video ID in the multi map //
			// if (xssfCell.getNumericCellValue()==vID) // use to check one by one e.g.
			// VID=1
			if (xssfCell.getStringCellValue().equals(vID)) // use to check one by one e.g. VID=E1
			{
				answer.add(xssfCell);
			}
		}
		return answer;
	}

	/**
	 * 
	 * @param keys
	 * @return
	 */
	// public static LinkedList<Integer> getDigitalObjectIdSet(Set<XSSFCell> keys) {
	public static LinkedList<String> getDigitalObjectIdSet(Set<XSSFCell> keys) {
		// LinkedList<Integer> answer = new LinkedList<>();
		LinkedList<String> answer = new LinkedList<>();
		for (XSSFCell xssfCell : keys) {

			// if (!answer.contains(xssfCell.getNumericCellValue()))
			if (!answer.contains(xssfCell.getStringCellValue())) {
				// answer.add((int) xssfCell.getNumericCellValue());
				answer.add(xssfCell.getStringCellValue());
			}
		}
		return answer;
	}
}