package DiversityPackage;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import javax.xml.parsers.ParserConfigurationException;
import org.apache.jena.ontology.OntClass;
import org.apache.jena.ontology.OntModel;
import org.apache.jena.ontology.OntModelSpec;
import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.QueryFactory;
import org.apache.jena.query.QuerySolutionMap;
import org.apache.jena.query.ResultSet;
import org.apache.jena.query.ResultSetFormatter;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Resource;
import org.xml.sax.SAXException;
import slib.utils.ex.SLIB_Exception;

public class DiversityProperties_Variety_Coverage_Balance_WithinDisparity {

	public static String Source;
	public static String EntryPoint;
	public static Hashtable<String, Hashtable<Object, Float>> DispersionPerSuperClassPerVideo = new Hashtable<String, Hashtable<Object, Float>>();
	public static Hashtable<String, Hashtable<String, Double>> SuperclassesProportionsPerVideo = new Hashtable<String, Hashtable<String, Double>>();
	public static Hashtable<String, Hashtable<String, Double>> SuperclassesCoveragePerVideo = new Hashtable<String, Hashtable<String, Double>>();
	public static Hashtable<String, Hashtable<String, ArrayList>> SuperclassesEntitiesPerVideo = new Hashtable<String, Hashtable<String, ArrayList>>();
	public static ArrayList<String> DSClassesFound = new ArrayList();
	public static ArrayList<String> Superclasses = new ArrayList();
	public static ArrayList<String> DistinctSClasses = new ArrayList();
	public static Hashtable<String, String> EntitiesAndSuperclasses = new Hashtable();

	public static RetrieveEntitiesFromXMl EntityFromXML = new RetrieveEntitiesFromXMl();// Starting with Thing
	public static RetrieveSuperclassesJena ThingSuperClass = new RetrieveSuperclassesJena(); // Starting with Thing
	public static RetrievingFromOntology O = new RetrievingFromOntology();
	public static ShortestPathFromSML Dispersion = new ShortestPathFromSML();
	public static RetrieveEntitiesFromGATEInlineXML GATEannotations = new RetrieveEntitiesFromGATEInlineXML();
	public static CountClassesAndInstances CountingInsclassJena = new CountClassesAndInstances();

	public static void main(String[] args)
			throws IOException, SLIB_Exception, SAXException, ParserConfigurationException {

		InputStreamReader istream = new InputStreamReader(System.in);
		BufferedReader BRead = new BufferedReader(istream);

		// Note: can read entry points and input files, but here they are put directly
		// to code for fast access and testing

		// Entry points: Thing or a class URI- must specify both, source ontology URI
		// and entry point, which is if "Thing" as well is same as ontology URI

		// e.g. Thing in presentation ontology

		Source = "Enter ontology URI here (e.g. PreSOn)";
		// e.g. Entry point in PreSOn Presentation Ontology
		EntryPoint = "Enter ontology/class URI";

		Hashtable<String, ArrayList> DiversityDimensionsPerVideo = new Hashtable();

		// CHECK IF ENRTY POINT IS THING/ontology URI i.e. Starting from the top of the
		// ontology
		if (Source.equals(EntryPoint)) {

			DiversityDimensionsPerVideo = FindThingTopSuperclasses();
		} else {

			DiversityDimensionsPerVideo = FindEPDirectSubClasses();

		}

		// Printing Results Diversity properties per video
		Enumeration<String> D = DiversityDimensionsPerVideo.keys();
		System.out.println(
				" Diversity has been calculated for" + "\t" + DiversityDimensionsPerVideo.size() + "\t" + "videos");
		System.out.println("************************* Entities for each super class*********************************");

		Enumeration e = SuperclassesEntitiesPerVideo.keys();
		while (e.hasMoreElements()) {
			Object VideoId = e.nextElement();
			Hashtable<String, ArrayList> SuperClassEntities = SuperclassesEntitiesPerVideo.get(VideoId);

			Enumeration e1 = SuperClassEntities.keys();
			while (e1.hasMoreElements()) {
				int AvailableClasses = 0;
				int AvailableInstances = 0;
				int AvailableEntities = 0;
				Object SuperClass = e1.nextElement();

				AvailableClasses = CountingInsclassJena.CountALLClassesJena(Source, SuperClass.toString());
				AvailableInstances = CountingInsclassJena.CountALLInstancesJena(Source, SuperClass.toString());
				AvailableEntities = AvailableClasses + AvailableInstances;

				ArrayList Entities = SuperClassEntities.get(SuperClass);
				for (int entity = 0; entity < Entities.size(); entity++) {
					System.out.println(VideoId + "\t" + SuperClass + "\t" + AvailableClasses + "\t" + AvailableInstances
							+ "\t" + AvailableEntities + "\t" + Entities.size() + "\t" + Entities.get(entity));
				}

			}

		}
		System.out.println("");
		System.out
				.println("************************* Dispersion for each super class*********************************");

		Enumeration en = DispersionPerSuperClassPerVideo.keys();
		while (en.hasMoreElements()) {
			Object VideoId = en.nextElement();
			Hashtable<Object, Float> SuperClassDispersion = DispersionPerSuperClassPerVideo.get(VideoId);

			Enumeration en1 = SuperClassDispersion.keys();
			while (en1.hasMoreElements()) {
				System.out.print(VideoId + "\t");
				Object Superclasses = en1.nextElement();
				float dispersion = SuperClassDispersion.get(Superclasses);
				System.out.print(Superclasses + "\t" + dispersion);
				System.out.println("");
			}

		}

		System.out.println("");
		System.out
				.println("************************* Proportions for each super class*********************************");
		System.out.println("");
		Enumeration en2 = SuperclassesProportionsPerVideo.keys();
		while (en2.hasMoreElements()) {
			Object VideoId = en2.nextElement();
			Hashtable<String, Double> SuperClassProportion = SuperclassesProportionsPerVideo.get(VideoId);

			Enumeration en3 = SuperClassProportion.keys();
			while (en3.hasMoreElements()) {
				System.out.print(VideoId + "\t");
				Object Superclass = en3.nextElement();
				Double proportion = SuperClassProportion.get(Superclass);
				System.out.print(Superclass + "\t" + proportion);
				System.out.println("");
			}

		}
		System.out.println("");

		System.out.println("");
		System.out.println("************************* Coverage for each super class*********************************");
		System.out.println("");

		Enumeration enc = SuperclassesCoveragePerVideo.keys();
		while (enc.hasMoreElements()) {
			Object VideoId = enc.nextElement();
			Hashtable<String, Double> SuperClassCoverage = SuperclassesCoveragePerVideo.get(VideoId);

			Enumeration en3 = SuperClassCoverage.keys();
			while (en3.hasMoreElements()) {
				System.out.print(VideoId + "\t");
				Object Superclass = en3.nextElement();
				Double coverage = SuperClassCoverage.get(Superclass);
				System.out.print(Superclass + "\t" + coverage);
				System.out.println("");
			}

		}
		System.out.println("");

		System.out.println(
				"****************Domain Diversity Zoom in*****************************************************");
		while (D.hasMoreElements()) {
			String VideoID = D.nextElement();
			ArrayList DiversityDimensions = DiversityDimensionsPerVideo.get(VideoID);
			System.out.print(VideoID);
			for (int i = 0; i < DiversityDimensions.size(); i++) {
				System.out.print("\t" + DiversityDimensions.get(i));

			}
			System.out.println();

		}

	}

	// **************** Thing Top super Classes********************
	// Retrieve entities
	private static Hashtable FindThingTopSuperclasses()
			throws SLIB_Exception, SAXException, IOException, ParserConfigurationException {
		// ArrayList <String> ThingDirectSubclasses= new ArrayList();
		ArrayList<String> Entities = new ArrayList<String>();// Dimolkis dataset
		Hashtable<String, ArrayList> EntitiesByVideoID = new Hashtable<String, ArrayList>();// = null;
		// Hashtable <String, Hashtable<String, Double>> diversityDimensionsPerVideo=
		// new Hashtable();
		Hashtable<String, ArrayList> diversityDimensionsPerVideo = new Hashtable();

		// use with data from YouTube dataset- domain body language
		// EntitiesByVideoID = EntityFromXML.RetrieveEntitiesByVideoIdFromXml(Source);

		// Use with annotated files in GATE-Inline XML files as output
		EntitiesByVideoID = GATEannotations.RetrieveFromGATEXML();

		// Call Diversity properties/Dimensions calculations functions
		Enumeration<String> e = EntitiesByVideoID.keys();
		System.out.println("The number of videos is:=  " + EntitiesByVideoID.size());

		// Diversity dimensions for each video
		while (e.hasMoreElements()) {
			int Variety = 0;
			double ShannonEntropyBalance = 0;
			double Coverage = 0;
			double Disparity = 0;

			Hashtable<String, Double> DimensionsValues = new Hashtable<String, Double>();
			ArrayList DDimensions = new ArrayList();

			String videoId = e.nextElement();
			Entities = EntitiesByVideoID.get(videoId);

			// Send only distinct entities for calculations
			ArrayList en = new ArrayList(Entities);
			HashSet DistinctEntities = new HashSet(en);
			ArrayList DEntities = new ArrayList(DistinctEntities);

			if (!(DEntities.isEmpty())) {
				Variety = CalculateVarietyThing(DEntities);
				DDimensions.add(Variety);

				ShannonEntropyBalance = CalculateBalance(videoId);
				DDimensions.add(ShannonEntropyBalance);

				Coverage = CalculateCoverage(videoId);
				DDimensions.add(Coverage);

				Disparity = CalculateDisparity(videoId);
				DDimensions.add(Disparity);

				diversityDimensionsPerVideo.put(videoId, DDimensions);

			} else // video has no entities from annotations
			{

				DDimensions.add(0.0);
				DDimensions.add(0.0);
				DDimensions.add(0.0);
				DDimensions.add(0.0);

				diversityDimensionsPerVideo.put(videoId, DDimensions);

			}
		}
		return diversityDimensionsPerVideo;
	}

	// ************ Entry Point Direct Sub Classes****************
	// Retrieve entities

	private static Hashtable<String, ArrayList> FindEPDirectSubClasses()
			throws SLIB_Exception, SAXException, IOException, ParserConfigurationException {
		ArrayList<String> Entities = new ArrayList<String>();
		ArrayList<String> EPDirectSubclasses = new ArrayList();
		ArrayList<String> EPDirectInstances = new ArrayList();
		ArrayList<String> EPSubclasses = new ArrayList();
		ArrayList<String> EPInstances = new ArrayList();
		ArrayList<String> EPAllChildren = new ArrayList();

		Hashtable<String, ArrayList> EntitiesByVideoID = new Hashtable<String, ArrayList>();
		Hashtable<String, ArrayList> diversityDimensionsPerVideo = new Hashtable();

		OntModel model = ModelFactory.createOntologyModel();// with YouTube dataset
		model.read(Source, "RDF/XML");

		EPDirectSubclasses = O.DirectSubclasses(Source, EntryPoint);
		if (EPDirectSubclasses.isEmpty()) {
			EPDirectInstances = O.RetrieveInstancesURI(Source, EntryPoint);
			if (EPDirectInstances.isEmpty()) {
				System.out.println(
						"the Entry point" + "/t" + EntryPoint + "/t" + " has No direct subclasses nor instances.");
				System.exit(0);
			} else {
				System.out.println(
						"The Entry Point is a class with no direct sub classes (i.e. no domain categories). Please try again");
				System.exit(0);
			}
		}
		// merge classes and instances lists TO HAVE all children
		EPSubclasses = O.SubclassesURI(Source, EntryPoint);
		System.out.println("EP Subclasses" + EPSubclasses.size());
		EPInstances = O.RetreiveAllInstancesURI(Source, EntryPoint);
		EPAllChildren.addAll(EPSubclasses);
		EPAllChildren.addAll(EPInstances); 
		// Use with YouTube dataset
		// EntitiesByVideoID = EEPFromXML.RetrieveEntitiesByVideoIdFromXml(Source,
		// EPAllChildren);

		// USE this with files annotated with GATE
		EntitiesByVideoID = GATEannotations.RetrieveFromGATEXMLEntryPoint(EPAllChildren);

		Enumeration<String> e = EntitiesByVideoID.keys();
		// Diversity properties for each video
		while (e.hasMoreElements()) {
			int Variety = 0;
			double ShannonEntropyBalance = 0;
			double Disparity = 0;
			double Coverage = 0;

			ArrayList DDimensions = new ArrayList();
			String videoId = e.nextElement();
			Entities = EntitiesByVideoID.get(videoId);

			// Send only distinct entities for calculations
			HashSet DistinctEntities = new HashSet(Entities);
			ArrayList DEntities = new ArrayList(DistinctEntities);
			if (!(DEntities.isEmpty())) {

				Variety = CalculateVarietyEP(DEntities, EPDirectSubclasses);
				DDimensions.add(Variety);

				ShannonEntropyBalance = CalculateBalance(videoId);
				DDimensions.add(ShannonEntropyBalance);

				Coverage = CalculateCoverage(videoId);
				DDimensions.add(Coverage);

				Disparity = CalculateDisparity(videoId);
				DDimensions.add(Disparity);

				diversityDimensionsPerVideo.put(videoId, DDimensions);
			} else {

				DDimensions.add(0.0);
				DDimensions.add(0.0);
				DDimensions.add(0.0);
				DDimensions.add(0.0);
				diversityDimensionsPerVideo.put(videoId, DDimensions);
			}
		}
		return diversityDimensionsPerVideo;

	}

	// ****************** Calculate Variety Entry Point**************************
	private static int CalculateVarietyEP(ArrayList<String> DEntities, ArrayList<String> EPDirectSubclasses) {
		int variety = 0;

		if (!(Superclasses.isEmpty())) {
			Superclasses.removeAll(Superclasses);
		}

		if (!(EntitiesAndSuperclasses.isEmpty())) {
			EntitiesAndSuperclasses.clear();
		}

		Hashtable SuperClassProportions = new Hashtable();
		Hashtable SuperClassesOfEntities = new Hashtable();

		for (int i = 0; i < EPDirectSubclasses.size(); i++) {

			ArrayList DSSubclasses = new ArrayList();
			ArrayList DSInstances = new ArrayList();
			ArrayList DSAllChildren = new ArrayList();
			ArrayList E = new ArrayList();
			DSSubclasses = O.SubclassesURI(Source, EPDirectSubclasses.get(i));
			DSInstances = O.RetreiveAllInstancesURI(Source, EPDirectSubclasses.get(i));
			DSAllChildren.addAll(DSSubclasses);
			DSAllChildren.addAll(DSInstances);

			for (int j = 0; j < DEntities.size(); j++) {

				if (DSAllChildren.contains(DEntities.get(j))) {

					E.add(DEntities.get(j));
					Superclasses.add(EPDirectSubclasses.get(i));
					SuperClassProportions.put(EPDirectSubclasses.get(i), DSAllChildren.size());
					EntitiesAndSuperclasses.put(DEntities.get(j), EPDirectSubclasses.get(i));

				}

			}
			if (!(E.isEmpty())) {
				SuperClassesOfEntities.put(EPDirectSubclasses.get(i), E);
			}

		}

		HashSet DistinctSuperclasses = new HashSet(Superclasses);
		ArrayList DSuperclasses = new ArrayList(DistinctSuperclasses);

		variety = DSuperclasses.size();

		return variety;

	}

	// ****************** Calculate Variety Thing*****************************
	private static int CalculateVarietyThing(ArrayList<String> DEntities) // with YouTube dataset
	// private static int CalculateVarietyThing(ArrayList DEntities) //with GATE
	// output annotated files
	{

		int Variety = 0;
		if (!(Superclasses.isEmpty())) {
			Superclasses.removeAll(Superclasses);
		}
		if (!(EntitiesAndSuperclasses.isEmpty())) {
			EntitiesAndSuperclasses.clear();
		}

		for (int i = 0; i < DEntities.size(); i++) {

			String EntitySuperClasses = ThingSuperClass.RetriveSuperClass(Source, (String) DEntities.get(i));

			if (!(DEntities.get(i).equals(EntitySuperClasses))) // filter out classes that are the same as superclass
			{
				Superclasses.add(EntitySuperClasses);
				EntitiesAndSuperclasses.put((String) DEntities.get(i), EntitySuperClasses);
			}
		}

		HashSet DistinctSuperclasses = new HashSet(Superclasses);
		ArrayList DSuperclasses = new ArrayList(DistinctSuperclasses);
		Variety = DSuperclasses.size();
		return Variety;
	}

	// *****************************Calculate Balance*******************************
	// generic for any entry point including THING
	private static double CalculateBalance(String videoId) {

		double ShannonEntropyBalance = 0;
		Hashtable<String, Double> SuperclassesProportions = new Hashtable();
		Hashtable<String, Integer> SuperclassesWithFrequency = new Hashtable();
		// Calculate used entities for proportions
		// if videos with no entities are not excluded empty super classes or remove
		// from public declaration
		for (int j = 0; j < Superclasses.size(); j++) {
			SuperclassesWithFrequency.put(Superclasses.get(j),
					Collections.frequency(Superclasses, Superclasses.get(j)));
		}

		Enumeration e = SuperclassesWithFrequency.keys();
		while (e.hasMoreElements()) {

			int AvailableEntities = 0;
			int NoSubclasses = 0;
			int NoInstances = 0;
			double proportion = 0.0;

			String tag = (String) e.nextElement();

			int UsedEntities = ((Integer) SuperclassesWithFrequency.get(tag)).intValue();
			NoInstances = CountingInsclassJena.CountALLInstancesJena(Source, tag);
			proportion = (double) UsedEntities / (double) Superclasses.size();

			SuperclassesProportions.put(tag, proportion);
		}
		SuperclassesProportionsPerVideo.put(videoId, SuperclassesProportions);

		Enumeration E = SuperclassesProportions.keys();
		while (E.hasMoreElements()) {
			String tag = (String) E.nextElement();
			double P = ((Double) SuperclassesProportions.get(tag)).doubleValue();
			ShannonEntropyBalance = ShannonEntropyBalance + (-(P * Math.log(P)));
		}
		return ShannonEntropyBalance;
	}

	// **********************Calculate Coverage********************
	// generic for any entry point including THING
	private static double CalculateCoverage(String videoId) {

		double Coverage = 0.0;
		double c = 0.0;
		Hashtable<String, Double> SuperclassesCoverage = new Hashtable();
		Hashtable<String, Integer> SuperclassesWithFrequency = new Hashtable();

		for (int j = 0; j < Superclasses.size(); j++) {
			SuperclassesWithFrequency.put(Superclasses.get(j),
					Collections.frequency(Superclasses, Superclasses.get(j)));
		}

		Enumeration e = SuperclassesWithFrequency.keys();
		while (e.hasMoreElements()) {
			int AvailableEntities = 0;
			int NoSubclasses = 0;
			int NoInstances = 0;
			double cover = 0.0;

			String tag = (String) e.nextElement();

			int UsedEntities = ((Integer) SuperclassesWithFrequency.get(tag)).intValue();
			NoSubclasses = CountingInsclassJena.CountALLClassesJena(Source, tag);
			NoInstances = CountingInsclassJena.CountALLInstancesJena(Source, tag);

			AvailableEntities = NoSubclasses + NoInstances;

			cover = (double) UsedEntities / (double) AvailableEntities;

			SuperclassesCoverage.put(tag, cover);
		}
		SuperclassesCoveragePerVideo.put(videoId, SuperclassesCoverage);

		Enumeration E = SuperclassesCoverage.keys();
		while (E.hasMoreElements()) {
			String tag = (String) E.nextElement();
			double P = ((Double) SuperclassesCoverage.get(tag)).doubleValue();
			c = c + P;

		}
		Coverage = c / SuperclassesCoverage.size();

		return Coverage;
	}

	// **********************Calculate Disparity*****************
	// generic for any entry point including THING
	private static double CalculateDisparity(String videoId) throws SLIB_Exception {
		double disparity = 0;
		Hashtable<Object, Float> SuperClassesDispersions = new Hashtable();
		Hashtable<String, ArrayList> EntitiesPerSuperClass = new Hashtable<String, ArrayList>();
		Hashtable<Object, Float> superClassDispersion = new Hashtable<Object, Float>();
		// prepare a hashtable containing each superclass (key) and its entities
		// (Arraylist) to find shortest path (disparity WITHIN categories).
		// Convert Array list to a HashSet to have distinct entities
		HashSet DistinctSuperClasses = new HashSet(Superclasses);
		// Push elements back to the array list
		ArrayList DSuperClasses = new ArrayList(DistinctSuperClasses);

		// Compare super classes to create hashtabe <Dsuperclass, ArryList(Dentities)>
		for (int i = 0; i < DSuperClasses.size(); i++) {
			String s = null;
			ArrayList EntitiesForSuperclass = new ArrayList();
			// in EntitiesAndSuperclasses, entity is the key
			Enumeration<String> e = EntitiesAndSuperclasses.keys();
			while (e.hasMoreElements()) {
				String entity = e.nextElement();
				String superclass = EntitiesAndSuperclasses.get(entity);
				if (superclass.equals(DSuperClasses.get(i))) {

					s = superclass;
					EntitiesForSuperclass.add(entity);
				}
			}

			if (!(EntitiesForSuperclass.isEmpty())) {
				EntitiesPerSuperClass.put(s, EntitiesForSuperclass);

				// Find super class dispersion

				SuperclassesEntitiesPerVideo.put(videoId, EntitiesPerSuperClass);
				superClassDispersion = Dispersion.computeShortestPath(EntitiesPerSuperClass, Source);

				DispersionPerSuperClassPerVideo.put(videoId, superClassDispersion);

				// ****************Calculating overall disparity of superclasses***************

				float meanSum = 0;
				Enumeration en1 = superClassDispersion.keys();
				while (en1.hasMoreElements()) {
					Object superclass1 = en1.nextElement();
					float dispersion1 = superClassDispersion.get(superclass1);
					meanSum = meanSum + dispersion1;
				}

				float disparityBH = meanSum / DSuperClasses.size();
				disparity = (double) disparityBH;

			}

			else {
				disparity = 0;
			}

		}

		return disparity;
	}

}