package DiversityPackage;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Hashtable;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.*;
import org.xml.sax.SAXException;

public class RetrieveEntitiesFromXMl {

	private static String findVideoId(Element entity) {

		Node parent;
		Node parentSibling = null;
		boolean result = false;
		parent = entity.getParentNode();
		Node parentOfParent = parent.getParentNode();
		NodeList parentSiblings = parentOfParent.getChildNodes();
		for (int i = 0; i < parentSiblings.getLength(); i++) {
			Node sibling = parentSiblings.item(i);
			if (sibling.getNodeName() == "DigitalObject__Id") {
				parentSibling = sibling;
				break;
			}
		}
		return parentSibling.getTextContent();
	}

	public static Hashtable<String, ArrayList> RetrieveEntitiesByVideoIdFromXml(String Source)

	{
		String EntityUri = Source + "#";
		Hashtable<String, ArrayList> entitiesByVideo = new Hashtable<String, ArrayList>();
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		try {
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document doc = builder.parse("YTJIDATAANNOTATED.xml");// for 600 videos YouTube data set
			Element documentElement = doc.getDocumentElement();
			NodeList documentElementChildren = documentElement.getChildNodes();

			for (int i = 0; i < documentElementChildren.getLength(); i++) {
				NodeList entitiesUri;
				Node e = documentElementChildren.item(i);
				if (e.getNodeType() == Node.ELEMENT_NODE) {

					Element Echild = (Element) e;
					String videoID = getChild(Echild);
					ArrayList<String> entities = new ArrayList<String>();
					entitiesUri = doc.getElementsByTagName("Uri"); // use with YouTube data sets
					for (int j = 0; j < entitiesUri.getLength(); j++) {
						Node E = entitiesUri.item(j);
						String URI;
						if (E.getNodeType() == Node.ELEMENT_NODE) {
							Element Entity = (Element) E;
							URI = Entity.getTextContent();

							if (URI.contains(EntityUri)) {
								String EvideoID = findVideoId(Entity);
								if (videoID.equals(EvideoID)) {
									entities.add(URI);
								}
							}
						}
					}

					// Convert Array list to a HashSet to have distinct entities
					HashSet DEntities = new HashSet(entities);
					// Push elements back to the array list
					ArrayList DistinctEntities = new ArrayList(DEntities);
					// send non distinct entities to be able to calculate proportions for balance
					entitiesByVideo.put(videoID, entities);
				}
			}

		} catch (ParserConfigurationException e) {

			e.printStackTrace();
		} catch (SAXException e) {

			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return entitiesByVideo;

	}

	private static String getChild(Element echild) {
		String child = null;
		NodeList Children = echild.getChildNodes();
		for (int i = 0; i < Children.getLength(); i++) {
			if (Children.item(i).getNodeType() == 1) {
				if (Children.item(i).getNodeName() == "Id")// check if element node
				{
					child = Children.item(i).getTextContent();
				}
			}
		}
		return child;
	}
}
