
package DiversityPackage;

import java.util.ArrayList;
import org.apache.jena.ontology.Individual;
import org.apache.jena.ontology.OntClass;
import org.apache.jena.ontology.OntModel;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.util.iterator.ExtendedIterator;

public class RetrieveSuperclassesJena {

	public static String RetriveSuperClass(String Source, String URI) {

		ArrayList IndividualSuperclasses = new ArrayList();
		ArrayList ThingDirectSubClasses = new ArrayList();
		ArrayList ClassSuperClass = new ArrayList();
		ArrayList individuals = new ArrayList();
		String SuprerClass = null;

		OntModel model = ModelFactory.createOntologyModel();
		model.read(Source, "RDF/XML");

		// Retrieve Thing direct subclasses

		for (ExtendedIterator<OntClass> l = model.listHierarchyRootClasses(); l.hasNext();) {
			OntClass ThingSubclasses = l.next();
			ThingDirectSubClasses.add(ThingSubclasses);
		}

		// Remove Equivalent classes-ThingSubclasses

		for (int i = 0; i < ThingDirectSubClasses.size(); i++) {
			for (int j = 0; j < ThingDirectSubClasses.size(); j++) {

				if (((OntClass) ThingDirectSubClasses.get(i))
						.hasEquivalentClass((OntClass) ThingDirectSubClasses.get(j))) {

					ThingDirectSubClasses.remove(ThingDirectSubClasses.get(j));
				}

			}
		}

		// check if the URI is individual
		if (model.getIndividual(URI).isIndividual()) {
			Individual d = model.getIndividual(URI);
			for (ExtendedIterator<OntClass> i = d.listOntClasses(false); i.hasNext();) {
				OntClass cls = i.next();
				if (cls.isHierarchyRoot())

				{
					IndividualSuperclasses.add(cls);
				}

			}

			// retrieve only the top super class
			for (int o = 0; o < IndividualSuperclasses.size(); o++) {
				if (ThingDirectSubClasses.contains(IndividualSuperclasses.get(o))) {

					SuprerClass = IndividualSuperclasses.get(o).toString();
				}
			}

		}

		// URI is for a class
		else {
			Resource r = model.getResource(URI);
			OntClass Concept = r.as(OntClass.class);

			// check if the class is the top super class
			if (Concept.isHierarchyRoot()) {
				SuprerClass = Concept.toString();
			} else {
				for (ExtendedIterator<OntClass> j = Concept.listSuperClasses(false); j.hasNext();) {
					OntClass cls = j.next();
					if (cls.isHierarchyRoot()) {
						ClassSuperClass.add(cls);
					}

				}
				// retrieve only the top super class
				for (int o = 0; o < ClassSuperClass.size(); o++) {
					if (ThingDirectSubClasses.contains(ClassSuperClass.get(o))) {

						SuprerClass = ClassSuperClass.get(o).toString();
					}
				}
			}
		}
		return SuprerClass;

	}
}
