package DiversityPackage;

import java.util.ArrayList;
//import org.apache.jena.ontology.Individual;
import org.apache.jena.ontology.OntClass;
import org.apache.jena.ontology.OntModel;
import org.apache.jena.ontology.OntModelSpec;
//import org.apache.jena.ontology.OntResource;
//import org.apache.jena.query.ParameterizedSparqlString;
import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.QueryFactory;
import org.apache.jena.query.QuerySolution;
import org.apache.jena.query.QuerySolutionMap;
import org.apache.jena.query.ResultSet;
import org.apache.jena.rdf.model.Literal;
//import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Resource;

//import org.apache.jena.sparql.util.IterLib;
//import org.apache.jena.util.iterator.ExtendedIterator;
public class RetrievingFromOntology {

	// 1.***************************************Retrieve Direct
	// Subclasses********************************

	public static ArrayList DirectSubclasses(String Source, String EntryPoint) {
		ArrayList Q = new ArrayList();
		// OntModelSpec.OWL_MEM retrieves direct subclasses; while
		// OntModelSpec.OWL_MEM_MICRO_RULE_INF retrieves all subclasses anyway; same for
		// direct instances
		// String NS = Source + "#";
		OntModel model = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
		model.read(Source, "RDF/XML");
		// Resource r = model.getResource( NS + EntryPoint );
		Resource r = model.getResource(EntryPoint);
		OntClass Concept = r.as(OntClass.class);
		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "SELECT ?subject"
				+ " WHERE { ?subject rdfs:subClassOf ?Concept;" + "FILTER  (?subject != ?Concept)" +

				"}\n";

		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();

		while (resultSet.hasNext()) {
			QuerySolution solution = resultSet.next();
			String subject = solution.get("subject").toString();
			Q.add(subject);
		}

		qe.close();
		return Q;

	}

	// 2.*********************************Retrieves All
	// Subclasses*************************************

	public static ArrayList Subclasses(String Source, String EntryPoint) {
		ArrayList Q = new ArrayList();
		String NS = Source + "#";
		OntModel model = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(NS + EntryPoint);
		OntClass Concept = r.as(OntClass.class);

		// *************************Using SPARQLE*******************************

		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "SELECT ?subject"
				+ " WHERE { ?subject rdfs:subClassOf* ?Concept " + "FILTER (?subject != ?Concept) " + "}\n";
		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();
		while (resultSet.hasNext()) {
			QuerySolution solution = resultSet.next();
			String subject = solution.get("subject").toString();
			Q.add(subject);

		}
		qe.close();
		return Q;
	}

	// 3.********************Retrieve Direct
	// Instances************************************

	public static ArrayList RetrieveInstances(String Source, String EntryPoint) {
		ArrayList Q = new ArrayList();
		String NS = Source + "#";
		OntModel model = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(NS + EntryPoint);
		OntClass Concept = r.as(OntClass.class);

		// *************************Using SPARQLE*******************************

		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "select  ?instance "
				+ " WHERE { ?instance a ?Concept " +

				"}\n";
		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();

		while (resultSet.hasNext()) {
			QuerySolution solution = resultSet.next();
			String instance = solution.get("instance").toString();
			Q.add(instance);

		}
		qe.close();
		return Q;

	}

	// 4.*********************************Retrieves All
	// Instances************************************

	public static ArrayList RetreiveAllInstances(String Source, String EntryPoint) {
		ArrayList Q = new ArrayList();
		// entry point is NOT URI
		String NS = Source + "#";
		OntModel model = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(NS + EntryPoint);
		OntClass Concept = r.as(OntClass.class);

		// *************************Using SPARQLE*******************************

		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "SELECT ?AllInstances"
				+ " WHERE { ?subject rdfs:subClassOf* ?Concept." + "?AllInstances a  ?subject" + "}\n";

		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();

		while (resultSet.hasNext()) {
			QuerySolution solution = resultSet.next();
			String AllInstances = solution.get("AllInstances").toString();
			Q.add(AllInstances);

		}
		qe.close();
		return Q;

	}

	// 5.*********************************Retrieves All Subclasses Using
	// URI*************************************

	public static ArrayList SubclassesURI(String Source, String URI) {
		ArrayList Q = new ArrayList();
		// String NS = Source + "#";
		OntModel model = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(URI);
		OntClass Concept = r.as(OntClass.class);

		// *************************Using parametrised
		// SPARQLE*******************************

		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "SELECT ?subject"
				+ " WHERE { ?subject rdfs:subClassOf* ?Concept " + "FILTER (?subject != ?Concept) " + "}\n";
		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();
		while (resultSet.hasNext()) {
			QuerySolution solution = resultSet.next();
			String subject = solution.get("subject").toString();
			Q.add(subject);

		}
		qe.close();
		return Q;
	}

	// 6.********************Retrieve Direct Instances Using
	// URI************************************

	public static ArrayList RetrieveInstancesURI(String Source, String URI) {
		ArrayList Q = new ArrayList();
		OntModel model = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(URI);
		OntClass Concept = r.as(OntClass.class);

		// *************************Using parametrised
		// SPARQLE*******************************

		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "select  ?instance "
				+ " WHERE { ?instance a ?Concept " +

				"}\n";
		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();

		while (resultSet.hasNext()) {
			QuerySolution solution = resultSet.next();
			String instance = solution.get("instance").toString();
			Q.add(instance);

		}
		qe.close();
		return Q;

	}
	// 4.*********************************Retrieves All
	// Instances************************************

	public static ArrayList RetreiveAllInstancesURI(String Source, String URI) {
		ArrayList Q = new ArrayList();
		// String NS = Source + "#";
		OntModel model = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM);
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(URI);
		OntClass Concept = r.as(OntClass.class);

		// *************************Using SPARQLE*******************************

		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "SELECT ?AllInstances"
				+ " WHERE { ?subject rdfs:subClassOf* ?Concept." + "?AllInstances a  ?subject" + "}\n";

		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();

		while (resultSet.hasNext()) {
			QuerySolution solution = resultSet.next();
			String AllInstances = solution.get("AllInstances").toString();
			Q.add(AllInstances);

		}
		qe.close();
		return Q;

	}

	// 5. Super classes using URI as a string****************************

	public static ArrayList SuperClassesURI(String Source, String URI) {
		System.out.println("Find super class");
		// Not finished refine results to be saved in top super class
		ArrayList Q = new ArrayList();
		String TopSuperClass;
		OntModel model = ModelFactory.createOntologyModel();
		model.read(Source, "RDF/XML");
		if (model.getIndividual(URI).isIndividual()) {
			System.out.println(URI + "is a individual");

			// TopSuperClass= Q.get(Q.size()).toString();
			Resource r = model.getResource(URI);
			OntClass Concept = r.as(OntClass.class);
			QuerySolutionMap initialSettings = new QuerySolutionMap();
			initialSettings.add("Concept", Concept);

			String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
					+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
					+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
					+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "SELECT ?superclass"
					+ " WHERE {?subject rdfs:subClassOf * ?superclass." + "      ?Concept a ?subject.}" + "}\n";

			org.apache.jena.query.Query query = QueryFactory.create(queryString);
			QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

			ResultSet resultSet = qe.execSelect();

			while (resultSet.hasNext()) {
				System.out.println("found the suoer class add it to list");
				QuerySolution solution = resultSet.next();
				String superclass = solution.get("superclass").toString();
				Q.add(superclass);

			}
			qe.close();
		}

		else {

			System.out.println(URI + " is a Class");
			Resource r = model.getResource(URI);
			OntClass Concept = r.as(OntClass.class);
			QuerySolutionMap initialSettings = new QuerySolutionMap();
			initialSettings.add("Concept", Concept);

			String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
					+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
					+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
					+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>" + "SELECT ?superclass"
					+ " WHERE {?Concept  rdfs:subClassOf* ?superclass." + "  FILTER (?superclass != ?Concept)" + "}\n";

			org.apache.jena.query.Query query = QueryFactory.create(queryString);
			QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

			ResultSet resultSet = qe.execSelect();

			while (resultSet.hasNext()) {
				QuerySolution solution = resultSet.next();
				String superclass = solution.get("superclass").toString();
				Q.add(superclass);

			}
			qe.close();
		}

		// TopSuperClass= Q.get(Q.size()).toString();
		// return TopSuperClass;
		return Q;
	}

	// 6.***********************************Count ALL
	// subclasses**********************************************
	public static int CountSubclasses(String Source, String URI) {
		int NoSubclasses = 0;

		OntModel model = ModelFactory.createOntologyModel();
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(URI);
		OntClass Concept = r.as(OntClass.class);

		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>"
				+ "select  (count(?subject) as ?Number_of_Subclasses) " + " WHERE { ?subject rdfs:subClassOf* ?Concept "
				+ "}\n";
		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();

		while (resultSet.hasNext()) {
			QuerySolution Solution = resultSet.next();
			Literal Subclasses = (Literal) Solution.get("Number_of_Subclasses");
			NoSubclasses = Subclasses.getInt();
		}

		qe.close();

		return NoSubclasses;
	}

	// .7***********************************Count ALL
	// Instances**********************************************
	public static int CountALLInstances(String Source, String URI) {
		int NoInstances = 0;

		OntModel model = ModelFactory.createOntologyModel();
		model.read(Source, "RDF/XML");
		Resource r = model.getResource(URI);
		OntClass Concept = r.as(OntClass.class);
		QuerySolutionMap initialSettings = new QuerySolutionMap();
		initialSettings.add("Concept", Concept);

		String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#>"
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>"
				+ "select  (count(?instance) as ?Number_of_All_Instances) "
				+ "WHERE{ ?subject rdfs:subClassOf* ?Concept." + "       ?instance a ?subject " + "}\n";

		org.apache.jena.query.Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model, initialSettings);

		ResultSet resultSet = qe.execSelect();
		while (resultSet.hasNext()) {
			QuerySolution Solution = resultSet.next();
			Literal Instances = (Literal) Solution.get("Number_of_All_Instances");
			NoInstances = Instances.getInt();
		}

		qe.close();

		return NoInstances;

	}

}
